---
title: HTMLImageElement.complete
slug: Web/API/HTMLImageElement/complete
tags:
  - API
  - Fetching
  - HTML
  - HTML DOM
  - HTMLImageElement
  - Loading
  - Property
  - Reference
  - complete
---
<p>{{APIRef("HTML DOM")}}</p>

<p><span class="seoSummary">The read-only {{domxref("HTMLImageElement")}} interface's <code><strong>complete</strong></code> attribute is a Boolean value which indicates whether or not the image has completely loaded.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>doneLoading</em> = <em>htmlImageElement</em>.complete;</pre>

<h3 id="Value">Value</h3>

<p>A Boolean value which is <code>true</code> if the image has completely loaded; otherwise, the value is <code>false</code>.</p>

<p>The image is considered completely loaded if any of the following are true:</p>

<ul>
 <li>Neither the {{htmlattrxref("src", "img")}} nor the {{htmlattrxref("srcset", "img")}} attribute is specified.</li>
 <li>The <code>srcset</code> attribute is absent and the <code>src</code> attribute, while specified, is the empty string (<code>""</code>).</li>
 <li>The image resource has been fully fetched and has been queued for rendering/compositing.</li>
 <li>The image element has previously determined that the image is fully available and ready for use.</li>
 <li>The image is "broken;" that is, the image failed to load due to an error or because image loading is disabled.</li>
</ul>

<p>It's worth noting that due to the image potentially being received asynchronously, the value of <code>complete</code> may change while your script is running.</p>

<h2 id="Examples">Examples</h2>

<p>Consider a photo library app that provides the ability to open images into a lightbox mode for improved viewing as well as editing of the image. These photos may be very large, so you don't want to wait for them to load, so your code uses <code>async</code>/<code>await</code> to load the images in the background.</p>

<p>But imagine that you have other code that needs to only run when the image has completed loading, such as a command that performs red-eye removal on the image in the lightbox. While ideally this command wouldn't even be executed if the image hasn't fully loaded, for improved reliability you want to check to ensure this is the case.</p>

<p>So the <code>fixRedEyeCommand()</code> function, which is called by the button that triggers red-eye removal, checks the value of the lightbox image's <code>complete</code> property before attempting to do its work. This is demonstrated in the code below.</p>

<pre class="brush: js notranslate">let lightboxElem = document.querySelector("#lightbox");
let lightboxImgElem = lightboxElem.querySelector("img");
let lightboxControlsElem = lightboxElem.querySelector(".toolbar");

async function loadImage(url, elem) {
  return new Promise((resolve, reject) =&gt; {
    elem.onload = () =&gt; resolve(elem);
    elem.onerror = reject;
    elem.src = url;
  });
}

async function lightBox(url) {
  lightboxElem.style.display = "block";
  await loadImage("https://somesite.net/huge-image.jpg", lightboxImgElem);
  lightboxControlsElem.disabled = false;
}

/* ... */

function fixRedEyeCommand() {
  if (lightboxElem.style.display === "block" &amp;&amp; lightboxImgElem.complete) {
    fixRedEye(lightboxImgElem);
  } else {
    /* can't start doing this until the image is fully loaded */
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-img-complete', 'HTMLImageElement.complete')}}</td>
   <td>{{Spec2('HTML DOM')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLImageElement.complete")}}</p>
